#####################################################
# E-Blah Bulliten Board Systems  -  Platinum Series #
#####################################################
# Copyright (c) 2001 - 2006 E-Blah.                 #
#####################################################

use Time::Local 'timelocal';

CoreLoad('Calendar',1);

{
	# Prepare the groups for calendar modding
	foreach(@fullgroups) {
		foreach $un (split(",",$permissions{$_,'manager'})) {
			$managers{$_,$un} = 1;
			$manager{$un} = 1;
		}
	}

	$managers{'myself',$username} = 1;
}

sub CalendarLoad {
	my($next,$last);
	# We need to get a few globls for the Calendar, here they are:
	$kday = $Kday; $kmon = $Kmonth; $kyear = $Kyear;

	# Lets get the varibles in, and check for errors
	if($URL{'month'} ne '') { $kmon = $URL{'month'}-1; }
	$gmonth = $gmonth2 = $kmon;
	++$gmonth2;
	$gyear = $URL{'year'} || $kyear;
	if($gyear > 2015 || $gyear < 1995) { $gyear = $kyear; }
	if($gmonth < 0 || $gmonth > 11) { $gmonth = $kmon; }
	$gyear2 = $gyear - 1900;
	$keepyear = $gyear;

	if($URL{'v'} ne 'mod') { Month(); }
}

sub Month {
	if($gyear eq '' && $gmonth eq '') { error("Please reupload $scriptname!"); }
	eval { $mstart = timelocal(1,1,1,1,$gmonth,$gyear,1); };
	($t,$t,$t,$qmday,$qmon,$qyear,$qwday,$qyday) = localtime($mstart);

	if($URL{'id'} ne '') { ShowID(); }

	$title = "$months[$gmonth] $keepyear";
	header();

	$ebout .= <<"EOT";
<table width="100%" cellpadding="0" cellspacing="0">
 <tr>
  <td width="76%" valign="top">
EOT
	if($URL{'id'} ne '') { $ebout .= $event; }
	elsif($URL{'week'}) { WeekView(); }
		else {
			MonthView();
			if(!$URL{'month'} && !$URL{'year'}) { UpcomingEvents(); }
		}

	$ebout .= <<"EOT";
  </td><td>&nbsp;</td><td valign="top">
EOT
	if($URL{'week'} eq '' && $URL{'id'} eq '') {
		($t,$t,$t,$t,$qmon,$qyear) = localtime($mstart-86400); # Get last month
		eval { $mstart2 = timelocal(1,1,1,1,$qmon,$qyear,1); };
		SimpleCalendar($mstart2, $calendar[29]);
		$ebout .= "<br>";

		($t,$t,$t,$t,$qmon,$qyear) = localtime($mstart+2937600); # Get next month (36 days ahead)
		eval { $mstart2 = timelocal(1,1,1,1,$qmon,$qyear,1); };
		SimpleCalendar($mstart2, $calendar[31]);
	}
		else {
			if($nonoyr == 1990) {
				eval { $mstart = timelocal(1,1,1,1,$kmon,$kyear,1); };
			}
			SimpleCalendar($mstart, $calendar[32]);
		}
	OtherOptions();
	$ebout .= <<"EOT";
  </td>
 </tr>
</table>
EOT

	footer();
	exit;
}

sub UpcomingEvents {
	for($c = 1; $c <= 90; ++$c) {
		($t,$t,$t,$ttday,$tthismon,$tyear) = gmtime((time+(3600*($settings[15]+$settings[31]+$gtoff)))+(86400*$c));
		$temp = $Events{"$tthismon|$ttday|$tyear"}.$Events{"$tthismon|$ttday|90"};
		foreach(@useonce) {
			if($temp =~ /\Q$_\E/) {
				if($used{$_}) { $temp =~ s~\Q$_\E~~gis; }
				$used{$_} = 1;
			}
		}
		$tom .= $temp;
		if($temp) { push(@all,"$tthismon|$tyear|$ttday|$temp"); }
	}

	$events = $Events{"$thismon|$tday|$qyear"}.$Events{"$thismon|$tday|90"};
	$events =~ s/, \Z//;
	$events = $events || "NONE!!!!!!"; # None!

	$ebout .= <<"EOT";
<br><table cellpadding="4" cellspacing="1" width="100%" class="border">
 <tr>
  <td class="titlebg">$calendar[55]</td>
 </tr><tr>
  <td class="win">
   <table cellpadding="5" cellspacing="0" width="100%">
EOT
	foreach(@all) {
		($mnt,$yr,$d,$events) = split(/\|/,$_);
		$yr += 1900;
		$events =~ s/, \Z//;

		if($mnt != $cmnt || $yr != $cyr) {
			if($cyr) { $ebout .= "<tr><td><br></td></tr>"; }
			$ebout .= <<"EOT";
 <tr><td colspan="2" class="win2" style="padding: 5px"><b>$months[$mnt] $yr</b></td></tr>
EOT
			$cmnt = $mnt;
			$cyr = $yr;
		}
		$ebout .= <<"EOT";
<tr>
 <td width="50%">$events</td>
 <td width="50%">$months[$mnt] $d, $yr</td>
</tr>
EOT
	}
	if($all[0] eq '') { $ebout .= qq~<tr><td align="center"><br>$calendar[56]<br><br></td></tr>~; }

	$ebout .= <<"EOT";
   </table>
  </td>
 </tr>
</table>
EOT
}

sub WeekView {
	$ebout .= <<"EOT";
   <table cellpadding="5" cellspacing="1" width="100%" class="border">
    <tr>
     <td class="titlebg" colspan="2"><b>$calendar[33] - $title</b></td>
    </tr>
EOT
	$days = CheckDays($gmonth);

	$daycnt = 1;
	$qwday2 = $qwday;
	++$qwday;
	$numweeks = 1;
	GetBirthdays();
	GetEvents();
	for($i = $qwday; $i <= 7; $i++) {
		if($numweeks == $URL{'week'}) {
			if($BirthDay{"$gmonth|$daycnt"}) {
				$BirthDay{"$gmonth|$daycnt"} =~ s/, \Z//;
				$birthdays = qq~<b>Birthdays:</b> $BirthDay{"$gmonth|$daycnt"}~;
			} else { $birthdays = ''; }
			if($Events{"$gmonth|$daycnt|$gyear2"} ne '' || $Events{"$gmonth|$daycnt|90"} ne '') {
				$events = $Events{"$gmonth|$daycnt|$gyear2"}.$Events{"$gmonth|$daycnt|90"};
				$events =~ s/, \Z//;
				$events .= "<br>";
			} else { $events = ''; }
			if($birthdays eq '' && $events eq '') { $events = $calendar[34]; }
			$ebout .= <<"EOT";
    <tr>
     <td class="catbg" colspan="2"><b>$days[($i-1)]</b></td>
    </tr><tr>
     <td class="win" width="50" align="center"><font size="5"><b>$daycnt</b></font></td>
     <td class="win2" valign="top" width="93%">$events $birthdays</td>
    </tr>
EOT
			$weekshown = 1;
		}
		if($days == $daycnt) { last; }
		if($i == 7 && $days > $daycnt) {
			++$numweeks;
			$i = 0;
		}
		++$daycnt;
	}
	if(!$weekshown) {
		$ebout .= <<"EOT";
    <tr>
     <td class="win" colspan="2">$calendar[35]</td>
    </tr>
EOT
	}

	$ebout .= "</table>";
}

sub OtherOptions {
	$sel{$gmonth} = ' selected';
	for($x = 0; $x < 12; ++$x) { $current .= qq~<option value="~.($x+1).qq~"$sel{$x}>$months[$x]</option>\n~; }
	$yrs{$gyear} = " selected";
	for($ey = -2; $ey < 3; $ey++) {
		$curyr = $gyear+$ey;
		if($curyr < 1995 || $curyr > 2015) { next; }
		$yearzz .= qq~<option value="$curyr"$yrs{$curyr}>$curyr</option>~;
	}

	$ebout .= <<"EOT";
<script language="JavaScript">
<!--
function JumpTo(ghere,year) {
 location = "$surl\lv-cal/month-"+ghere+"/year-"+year+"/";
}
//-->
</script>
   <br><table cellpadding="5" cellspacing="1" class="border" width="100%">
    <tr>
     <td class="titlebg"><b>$calendar[37]</b></td>
    </tr><tr>
     <td class="win">
      <table width="100%">
       <tr>
        <td align="center" colspan="2" class="smalltext">$months[$gmonth] $keepyear</td>
       </tr><tr>
        <td class="smalltext"><b>$calendar[38]:</b></td>
        <td align="right"><select name="JumpZ" onChange="JumpTo(this.value,$gyear);">$current</select></td>
       </tr><tr>
        <td class="smalltext"><b>$calendar[39]:</b></td>
        <td align="right"><select name="JumpZ" onChange="JumpTo($gmonth+1,this.value);">$yearzz</select></td>
       </tr>
EOT
	unless($settings[1] eq '' || (!$enablecal && !$members{'Administrator',$username} && !$calmod)) {
		$ebout .= <<"EOT";
       <tr>
        <td colspan="2" align="center" class="smalltext"><hr class="hr" color="$color{'border'}" size="1"><a href="$surl\lv-mod/a-calendar/">$calendar[36]</a></td>
       </tr>
EOT
	}
	$ebout .= <<"EOT";
      </td>
     </table>
    </tr>
   </table>
EOT
}

sub SimpleCalendar {
	my($thisyear,$tempmonth2);
	my($mstart,$toptitle) = @_;

	($t,$t,$t,$t,$tempmonth,$tempyear,$mindent) = localtime($mstart);

	$thisyear = $tempyear+1900;
	$tempmonth2 = $tempmonth+1;

	$print = <<"EOT";
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td colspan="8" class="titlebg"><table cellpadding="0" cellspacing="0" width="100%"><tr><td class="titlebgtext"><b>$months[$tempmonth] $thisyear</b></td><td align="right" class="titlebgtext"><span class="smalltext">$toptitle</span></td></tr></table></td>
 </tr><tr>
  <td class="catbg" width="13">&nbsp;</td>
EOT
	for($i = 0; $i < 7; ++$i) {
		$print .= <<"EOT";
  <td class="catbg" align="center"><b>$smdlist[$i]</b></td>
EOT
	}
	$print .= "</tr>";

	if($mindent > 0) {
		$print .= <<"EOT";
 <tr>
  <td class="win" align="center"><b><a href="$surl\lv-cal/month-$tempmonth2/year-$thisyear/week-1/">&#155;</a></b></td>
  <td class="win" colspan="$mindent">&nbsp;</td>
EOT
	}
	$days = CheckDays($tempmonth);

	$daycnt = 1;
	++$mindent;
	$numweeks = 1;
	for($i = $mindent; $i <= 7; $i++) {
		if($kday == $daycnt && $kmon == $tempmonth && ($kyear == $tempyear+1900)) { $style = qq~ style="border:2px solid red; font-weight: bold"~; } else { $style = ''; }
		if($numweeks == $URL{'week'} && $style eq '' && $URL{'v'} eq 'cal') { $style2 = 'win3'; } else { $style2 = 'win2'; }
		if($i == 1) {
			$print .= qq~<td class="win" align="center"><b><a href="$surl\lv-cal/month-$tempmonth2/year-$thisyear/week-$numweeks/">&#155;</a></b></td>~;
		}
		$print .= qq~<td class="$style2" align="center"$style>$daycnt</td>~;
		if($i == 7 && $days > $daycnt) {
			$print .= "</tr>";
			++$numweeks;
			$i = 0;
		}
		if($days == $daycnt) { last; }
		++$daycnt;
	}

	if($i != 7) {
		$alldays = 7-$i;
		$print .= <<"EOT";
<td class="win" valign="top" colspan="$alldays">&nbsp;</td>
EOT
	}
	$print .= "</tr></table>";
	if($URL{'v'} eq cal) { $ebout .= $print; } else { return($print); }
}

sub MonthView {
	$ebout .= <<"EOT";
<table cellpadding="5" cellspacing="1" width="100%" class="border">
 <tr>
  <td class="titlebg" colspan="8"><b>$months[$gmonth] $keepyear</b></td>
 </tr><tr>
  <td class="catbg" width="20">&nbsp;</td>
EOT
	for($i = 0; $i < 7; ++$i) {
		$ebout .= <<"EOT";
  <td class="catbg" align="center" width="14%"><b>$days[$i]</b></td>
EOT
	}
	$ebout .= "</tr>";

	if($qwday > 0) {
		$ebout .= <<"EOT";
 <tr>
  <td class="win"><font size="2"><b><a href="$surl\lv-cal/month-$gmonth2/year-$gyear/week-1/">&nbsp;&#155;&nbsp;<br>&nbsp;&#155;&nbsp;<br>&nbsp;&#155;&nbsp;</a></b></font></td>
  <td class="win3" height="70" colspan="$qwday">&nbsp;</td>
EOT
		 $lweek = 1;
	}
	$days = CheckDays($gmonth);

	$qwday2 = $qwday;
	$daycnt = 1;
	++$qwday;
	GetBirthdays();
	GetEvents();
	$week = 1;
	for($i = $qwday; $i <= 7; $i++) {
		$BirthDay{"$gmonth|$daycnt"} =~ s/, \Z//;
		if($BirthDayC{"$gmonth|$daycnt"}) {
			$BirthDayL{"$gmonth|$daycnt"} =~ s/\n\Z//;
			$birthdays = qq~<a href="$surl\lv-cal/month-$gmonth2/year-$gyear/week-$week/" title="$BirthDayL{"$gmonth|$daycnt"}">$BirthDayC{"$gmonth|$daycnt"} $calendar[40]</a>~;
		}
			else { $birthdays = ''; }
		if($Events{"$gmonth|$daycnt|$gyear2"} ne '' || $Events{"$gmonth|$daycnt|90"} ne '') {
			$events = $Events{"$gmonth|$daycnt|$gyear2"}.$Events{"$gmonth|$daycnt|90"};
			$events =~ s/, \Z//;
			$events .= "<br>";
		} else { $events = ''; }
		if($week != $lweek) {
			$ebout .= qq~  <td class="win"><font size="2"><b><a href="$surl\lv-cal/month-$gmonth2/year-$gyear/week-$week/">&nbsp;&#155;&nbsp;<br>&nbsp;&#155;&nbsp;<br>&nbsp;&#155;&nbsp;</a></b></font></td>~;
			$lweek = $week;
		}

		if($kday == $daycnt && $kmon == $gmonth && $kyear == $gyear) { $style = ' style="border:2px solid red; padding: 1px; font-weight: bold"'; } else { $style = ' style="padding: 1px"'; }

		$ebout .= qq~  <td class="win2" height="90" valign="top"$style><div class="win" style="padding: 4px;"><b>$daycnt</b></div><div class="smalltext" style="margin: 5px;">$events$birthdays</div></td>~;
		if($i == 7 && $days > $daycnt) {
			++$week;
			$ebout .= '</tr>'; $i = 0;
		}
		if($days == $daycnt) { last; }
		++$daycnt;
	}

	if($i != 7) {
		$alldays = 7-$i;
		$ebout .= <<"EOT";
<td class="win3" height="90" valign="top" colspan="$alldays">&nbsp;</td>
EOT
	}

	$ebout .= <<"EOT";
 </tr>
</table>
EOT
}

sub GetBirthdays {
	fopen(FILE,"$members/List2.txt") || error($calendar[1]);
	@loadlist = <FILE>;
	fclose(FILE);
	chomp @loadlist;
	foreach(@loadlist) {
		($un,$sn,$t,$t,$bd) = split(/\|/,$_);
		next if($bd eq '');

		($bmon,$day,$year) = split("/",$bd);
		$bmon = sprintf("%.0f",$bmon)-1;
		$day = sprintf("%.0f",$day);

		$BirthDay{"$bmon|$day"} .= qq~<a href="$surl\lv-memberpanel/a-view/u-$un/">$sn</a>, ~;
		$BirthDayL{"$bmon|$day"} .= "$sn\n";
		++$BirthDayC{"$bmon|$day"};
	}
}

sub GetEvents {
	my($eventz);

	fopen(FILE,"$prefs/Events.txt");
	@events = <FILE>;
	fclose(FILE);
	chomp @events;

	if($enablecal) {
		fopen(FILE,"$members/$username.cal");
		@data = <FILE>;
		fclose(FILE);
		chomp @data;
		foreach(@data) { push(@events,"$_||1"); }
	}

	foreach(@events) {
		($id,$evdate,$title,$message,$author,$spanrange,$spancolor,$t,$groups) = split(/\|/,$_);

		$group{$id} = $groups;

		if($groups ne '' && (!$members{'Administrator',$username} && !$calmod)) {
			foreach(split(",",$group{$id})) {
				if($members{$_,$username}) { $allow{$id} = 1; }
			}
			next if(!$allow{$id});
		} else { $allow{$id} = 1; }

		if($spancolor eq '') { $spancolor = "clear"; }

		$eventz = qq~<span style="background: $spancolor; padding: 0px; font-weight: bold"><a href="$surl\lv-cal/id-$id/">$title</a></span>, ~;

		++$spanrange;
		if($spanrange) {
			for($za = 1; $za < $spanrange; $za++) {
				($t,$t,$t,$eday,$emon,$eyear) = localtime($evdate+(86400*$za));
				$Events{"$emon|$eday|$eyear"} .= $eventz;
			}
		}

		($t,$t,$t,$eday,$emon,$eyear) = localtime($evdate);
		$Events{"$emon|$eday|$eyear"} .= $eventz;
		push(@useonce,$eventz);
	}
}

sub ShowID {
	my($evtitled,$id,$evdate,$evtitle,$author,$spanrange,$spancolor,$topic);

	GetEvents();

	if(!$allow{$URL{'id'}}) { error($calendar[42]); }

	foreach(@events) {
		($id,$evdate,$evtitle,$mess,$author,$spanrange,$spancolor,$topic) = split(/\|/,$_);
		if($id == $URL{'id'}) {
			$message = $mess;
			($t,$t,$t,$eday,$emon,$eyear) = localtime($evdate);
			eval { $mstart = timelocal(1,1,1,1,$emon,$eyear,1); };
			$eyear += 1900;
			$nonoyr = $eyear;
			if($eyear != 1990) { $eyear = ", $eyear"; } else { $eyear = ''; }
			$datestart = "$months[$emon] $eday$eyear";
			if($spanrange) {
				($t,$t,$t,$eday,$emon,$eyear) = localtime($evdate+(86400*$spanrange));
				$eyear += 1900;
				if($eyear != 1990) { $eyear = ", $eyear"; } else { $eyear = ''; }
				$datestart .= " - $months[$emon] $eday$eyear";
			}
			if($URL{'id'} eq $id) { $evtitled = $evtitle; }
			loaduser($author);
			if($userset{$author}->[1]) { $user = qq~<b>$calendar[41]:</b> $userurl{$author}<br>~; } else { $user = ''; }
			last;
		}
	}
	if($evtitled eq '') { error($calendar[42]); }

	$title = $evtitled;

	unless($settings[1] eq '' || (!$enablecal && !$members{'Administrator',$username} && !$calmod)) { $modify = qq~<a href="$surl\lv-mod/a-calendar/edit-$URL{'id'}/">$img{'modify'}</a>~; }
	BC();

	$event = <<"EOT";
<table width="100%" cellpadding="5" cellspacing="1" class="border">
 <tr>
  <td class="titlebg">$evtitled</td>
 </tr><tr>
  <td class="win">
   <table cellpadding="0" cellspacing="0" width="100%">
    <tr>
     <td>$user<b>$calendar[43]:</b> $datestart</td>
     <td align="right">$modify</td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win2" class="postbody">$message</td>
 </tr>
</table>
EOT
}

sub CalendarEvents {
	if($username eq 'Guest' || (!$enablecal && !$members{'Administrator',$username} && !$calmod)) { error($gtxt{'noguest'}); }
	is_member();

	if($members{'Administrator',$username} || $calmod) {
		fopen(FILE,"$prefs/Events.txt");
		@events = <FILE>;
		fclose(FILE);
		chomp @events;
	}

	fopen(FILE,"$members/$username.cal");
	@data = <FILE>;
	fclose(FILE);
	chomp @data;
	foreach(@data) { push(@events,"$_||1"); }

	if($URL{'p'} eq 'save') { CalendarSave(); }

	foreach(@events) {
		($number,$edate2,$sum,$f,$author,$span,$spancolor,$type,$groups,$selfgrp) = split(/\|/,$_);
		($t,$t,$t,$qday,$qmon,$qyear) = localtime($edate);
		if($URL{'edit'} && $URL{'edit'} eq $number) { $group = $groups; $edate = $edate2; $showuser = $author eq '' ? 'checked' : ''; $summary = $sum; $full = Unformat($f); $remove = qq~ <input type="submit" class="button" value=" $calendar[13] " name="remove">~; $fnd = 1; last; }
	}
	if(!$fnd && $URL{'edit'}) { error($gtxt{'error2'}); }

	$edate = $edate || time;

	if($URL{'edit'}) { $title = $calendar[53]; } else {
		$number = $sum = $author = $span = $spancolor = $type = '';
		$title = $calendar[54];
	}

	header();
	$ebout .= <<"EOT";
<table cellpadding="4" cellspacing="1" class="border" width="750" align="center">
 <tr><form action="$surl\lv-mod/a-calendar/edit-$URL{'edit'}/p-save/" method="post" name="msend" enctype="multipart/form-data">
  <td class="titlebg"><b>$title</b></td>
 </tr><tr>
  <td class="win">
   <table width="100%">
    <tr>
     <td width="30%" align="right"><b>$calendar[44]:</b></td>
     <td><input type="text" class="textinput" name="evtitle" value="$summary" size="25"></td>
    </tr><tr>
     <td width="30%" align="right"><b>$calendar[45]:</b></td>
     <td><select name="month">
EOT
	($t,$t,$t,$qday,$qmon,$qyear) = localtime($edate);

	$mon{$qmon} = ' selected';
	for($i = 0; $i < 12; ++$i) {
		$ebout .= qq~<option value="$i"$mon{$i}>$months[$i]</option>~;
	}

	$ebout .= qq~</select> <select name="day">~;

	$day{$qday} = ' selected';
	for($i = 1; $i < 32; ++$i) { $ebout .= qq~<option value="$i"$day{$i}>$i</option>~; }
	$ebout .= qq~</select> <select name="year">~;
	$qyear += 1900;
	$yrs{$qyear} = " selected";
	if($qyear == 1990) { $qyear = 2005; }
	for($ey = -2; $ey < 3; $ey++) {
		$curyr = $qyear+$ey;
		$ebout .= qq~<option value="$curyr"$yrs{$curyr}>$curyr</option>~;
	}

	$ebout .= <<"EOT";
     <option value="1990"$yrs{1990}>$calendar[46]</option></select></td>
    </tr><tr>
     <td width="30%" align="right"><b>$calendar[47]:</b></td>
     <td><input type="text" class="textinput" name="span" value="$span" size="5"></td>
    </tr></tr>
     <td>&nbsp;</td><td><span class="smalltext">$calendar[48]</span></td>
    </tr><tr>
     <td width="30%" align="right"><b>$calendar[49]:</b></td>
     <td><input type="text" class="textinput" name="spancolor" value="$spancolor" size="10"></td>
    </tr></tr>
     <td>&nbsp;</td><td><span class="smalltext">$calendar[50]</span></td>
    </tr><tr>
     <td width="30%" align="right" valign="top"><b>$calendar[58]:</b></td>
     <td>
EOT
	if($calmod || $members{'Administrator',$username} || $manager{$username}) {
		if($selfgrp eq '') {
			foreach(split(",",$group)) {
				$t2{$_} = " selected";
			}
		} else { $t2{'myself'} = ' selected'; }

		$ebout .= qq~<select name="groups" size="5" multiple>~;
		foreach(split(',',$membergrp)) { $t2{$_} = ' selected'; }
		push(@fullgroups,('everyone','myself'));
		$members{'myself',$username} = $members{'everyone',$username} = 1;
		if(!$enablecal) { $members{'myself',$username} = 0; }
		$permissions{'myself','name'} = $calendar[61];
		$permissions{'everyone','name'} = $calendar[62];
		$ebout .= qq~<optgroup label="$calendar[60]">~;
		foreach(@fullgroups) {
			unless($members{'Administrator',$username} || $managers{$_,$username} || $calmod) { next; }
			if($permissions{$_,'pcount'} ne '' || $_ eq 'Moderators') { next; }
			if($_ eq 'everyone' || ($_ eq 'myself' && !$notshown)) { $ebout .= qq~</optgroup><optgroup label="$calendar[59]">~; $notshown = 1; }
			$ebout .= qq~<option value="$_"$t2{$_}>$permissions{$_,'name'}</option>~;
		}
		$ebout .= "</select>";
	} else {
		$ebout .= <<"EOT";
$calendar[57]
EOT
	}

	$ebout .= <<"EOT";
     </td>
    </tr><tr>
     <td width="30%" align="right"><b>$calendar[51]</b></td>
     <td><input type="checkbox" class="checkboxinput" name="showuser" value="1"$showuser></td>
    </tr></tr>
     <td>&nbsp;</td><td><span class="smalltext">$calendar[52]</span></td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	CoreLoad('Post');
	if($BCLoad || $BCSmile) { BCWait(); }
	if($BCLoad) { BCLoad(); }
	$ebout .= <<"EOT";
 <tr>
  <td class="win">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td align="right" width="30%" valign="top"><b>$calendar[24]:</b><br><br>
EOT

	if($BCSmile) { BCSmile(); }

	$ebout .= <<"EOT";
    </td>
     <td><textarea name="message" wrap="virtual" rows="12" cols="70">$full</textarea></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td align="center" class="win2"><input type="submit" class="button" value=" $calendar[28] " name="submit">$remove</td>
 </form></tr>
</table>
EOT
	footer();
	exit;
}

sub CalendarSave {
	$FORM{'year'} -= 1900;
	eval { $mstart = timelocal(1,1,1,$FORM{'day'},$FORM{'month'},$FORM{'year'},1); };
	$sum = Format($FORM{'evtitle'});
	$full = Format($FORM{'message'});
	error($gtxt{'long'}) if(length($full) > $maxmesslth && $maxmesslth);

	if($sum eq '' || $full eq '' || !$mstart || ($FORM{'span'} > 50)) { error($gtxt{'bfield'}); }

	if($FORM{'showuser'}) { $author = ''; } else { $author = $username; }

	$groups = '';
	foreach(split(',',$FORM{'groups'})) {
		if($_ eq 'myself') { $addtoself = 1; next; }
		if($_ eq 'everyone' && ($calmod || $members{'Administrator',$username})) { $addtoeveryone = 1; next; }
		unless($managers{$_,$username} || $calmod || $members{'Administrator',$username}) { next; }
		$groups .= "$_,";
	}
	$groups =~ s/,\Z//g;

	if($addtoeveryone) { $groups = ''; $addtoself = 0; }

	if($groups eq '' && $addtoeveryone eq '') { $addtoself = 1; }

	if(!$URL{'edit'}) {
		$count = time;

		if(($calmod || $members{'Administrator',$username} || $manager{$username}) && !$addtoself) {
			fopen(FILE,"+>>$prefs/Events.txt");
			print FILE qq~$count|$mstart|$sum|$full|$author|$FORM{'span'}|$FORM{'spancolor'}|0|$groups|\n~;
			fclose(FILE);
		} else {
			if($enablecal) {
				fopen(FILE,"+>>$members/$username.cal");
				print FILE qq~$count|$mstart|$sum|$full|$author|$FORM{'span'}|$FORM{'spancolor'}|0\n~; # DO NOT ADD ANYTHING ELSE!
				fclose(FILE);
			}
		}
	} else {
		foreach(@events) {
			($count,$odate,$osum,$ofull,$t,$t,$t,$t,$t,$selfish) = split(/\|/,$_);
			if($selfish eq '') { $selfish = 0; }
			if($count eq $URL{'edit'} && $FORM{'remove'}) { next; }
			elsif($count eq $URL{'edit'}) {
				if(!$addtoself) {
					$all{0} .= "$count|$mstart|$sum|$full|$author|$FORM{'span'}|$FORM{'spancolor'}|0|$groups|\n";
				} else { $all{1} .= "$count|$mstart|$sum|$full|$author|$FORM{'span'}|$FORM{'spancolor'}|0\n"; }
			}
				else { $all{$selfish} .= "$_\n"; }
		}

		if($enablecal) {
			fopen(FILE,"+>$members/$username.cal");
			print FILE $all{1};
			fclose(FILE);
		}

		if($members{'Administrator',$username} || $calmod || $manager{$username}) {
			fopen(FILE,"+>$prefs/Events.txt");
			print FILE $all{0};
			fclose(FILE);
		}
	}
	$url = "$surl\lv-cal/";
	if(!$FORM{'remove'}) { $url .= "id-$URL{'edit'}/"; }
	redirect();
}
1;